/* Doua variante de calculare a functiei Fibonacci: 
   iterativa si recursiva.

   Lansarea in executie a aplicatiei se face sub forma

     java Fibonacci n

   unde n este argumentul functiei Fibonacci(n) dat sub
   forma de numar intreg.
*/

class Fibonacci {

  /* Varianta recursiva a calcularii functiei Fibonacci */
  public static long fibonacci(long n) throws Exception {
    if(n<0) throw new Exception("Fibonacci arg<0: "+n);
    if ((n==0)||(n==1)) return 1;
    return fibonacci(n-1)+fibonacci(n-2);
  }

  /* Varianta iterativa a calcularii functiei Fibonacci */
  public static long fib(long n) throws Exception {
    if(n<0) throw new Exception("fib arg<0: "+n);
    if((n==0)||(n==1)) return 1;
    long f1=1, f2=1, f=0;// f1 si f2 sunt fib(i-1), respectiv fib(i-2) 
    for(long i=2; i<=n; i++) {
      f=f1+f2;
      f2=f1; f1=f;// se memoreaza valorile pentru iteratia urmatoare
    }
    return f;
  }

  /* Testarea celor doua variante. Argumentul functiei Fibonacci
     se da ca parametru in linia de comanda
  */
  public static void main(String args[]) {
    if(args.length==0) {
      System.out.println("Utilizare: Fibonacci n");
      System.exit(0);
    }
    try {
      long t1, t2, t3, t4, dt1, dt2, f1, f2;
      long n=Long.parseLong(args[0]);
      t1=System.currentTimeMillis();
      f1=fib(n);
      t2=System.currentTimeMillis();
      dt1=t2-t1;
      System.out.println("Iterativ Fibonacci("+n+") = "+f1+
          " timp calcul: "+dt1);
      t3=System.currentTimeMillis();
      f2=fibonacci(n);
      t4=System.currentTimeMillis();
      dt2=t4-t3;
      System.out.println("Recursiv Fibonacci("+n+") = "+f2+
         " timp calcul: "+dt2);
    }
    catch(Exception e) {
      System.out.println(e);
    }
  }
}
