public class HeapSort {
  public static void sort(double[] t) {
    int inou, itata;
    boolean stop;
    double elementMutat;
    if(t==null || t.length<3) return;
    /* Etapa 1: Crearea arborelui de selectie: se iau pe rand              
       elementele din tablou si se pun in arbore. Arborele ocupa
       prima parte a tabloului
    */ 
    for(int i=1; i<t.length; i++) { 
      /* elementul t[i] se pune in arbore; arborele se extinde 
         astfel pana la pozitia i a tabloului
      */
      inou=i;
      stop=false; 
      while(!stop && inou>0) { // noul nod se propaga in sus
        itata=(inou-1)/2;
        if(t[itata]<t[inou]) {
          elementMutat=t[inou];
          t[inou]=t[itata];
          t[itata]=elementMutat;
          inou=itata;
        }
        else stop=true; // sfarsit propagare
      } // sfarsit while
    } // sfarsit for

    /* Etapa 2: Extragere din arbore si punere in locul ramas liber
       Arborele se extinde pana la indicele ultim, care scade treptat
    */
    double elementExtras, aux; // elementul care se extrage din coada
    int ifiu1, ifiuAles;
    for(int ultim=t.length-1; ultim>0; ultim--) {
      elementExtras=t[0]; // se extrage din coada primul element
      t[0]=t[ultim]; // ultimul element se aduce pe prima pozitie
      stop=false;
      itata=0;
      while(!stop) { // se propaga in jos elementul nou pus in cap
        // se alege fiul cel mai mare
        ifiu1=2*itata+1;
        if(ifiu1>=ultim) stop=true;
        else {
          if(ifiu1==ultim-1) ifiuAles=ifiu1;
          else ifiuAles=(t[ifiu1]>t[ifiu1+1])?ifiu1:ifiu1+1;
          if(t[itata]<t[ifiuAles]) { // se propaga in jos
            aux=t[itata];
            t[itata]=t[ifiuAles];
            t[ifiuAles]=aux;
            itata=ifiuAles;
          } // sfarsit if
          else stop=true; // sfarsitul propagarii in jos
        } // sfarsit else
      } // sfarsit while - s-a terminat propagarea in jos
      t[ultim]=elementExtras; // se pune la sfarsit elementul extras
    } // sfarsit for

  }  // sfarsit metoda sort
}

