import java.util.*;

public class Combinari extends Backtracking {
  Object[] tabObj;
  int nrElemente;

  public Combinari(Object[] tablouObiecte, int numarElemente) {
    tabObj=tablouObiecte;
    nrElemente=numarElemente;
    ElemStiva elementGarda=new ElemStiva(null);
    stiva.add(elementGarda);
  }

  protected Object solutie() {
    if(stiva.size()<=nrElemente) return null;
    ArrayList solutie=new ArrayList();
    for(int j=1; j<stiva.size(); j++) {
      ElemStiva elementCurent=(ElemStiva)stiva.get(j);
      int indice=((Integer)elementCurent.element).intValue();
      solutie.add(tabObj[indice]);
    }
    return solutie;
  }

  protected Object succesor() {
    if(tabObj.length==0) return null;
    if(stiva.isEmpty() || stiva.size()==(nrElemente+1))
           return null;
    int j;
    ElemStiva varfStiva=(ElemStiva)stiva.get(stiva.size()-1);
    if(varfStiva.ultimSuccesorVizitat==null) return new Integer(0);
    j=((Integer)varfStiva.ultimSuccesorVizitat).intValue();
    if(j>=tabObj.length-1) return null;
    return new Integer(j+1);
  }

  protected boolean esteValid(Object succesor) {
    boolean valid=true;
    int inaltimeStiva=stiva.size();
    int k=((Integer)succesor).intValue();
    for(int i=1; i<inaltimeStiva && valid; i++) {
      ElemStiva curent=(ElemStiva)stiva.get(i);
      int j=((Integer)curent.element).intValue();
      if(k<=j) valid=false;
    }
    return valid;
  }
}
    