/* Generarea permutarilor de n obiecte folosind algoritmul
   backtracking. Obiectele permutate se gasesc in tabloul tabObj,
   care se da la initializare, ca argument al constructorului.
*/

import java.util.*;

public class Permutari extends Backtracking {
  Object[] tabObj;

  public Permutari(Object[] tablouObiecte) {
    tabObj=tablouObiecte;
    ElemStiva elementGarda=new ElemStiva(null);
    stiva.add(elementGarda);
  }

  /* Solutia trebuie sa contina toate obiectele din tabObj, deci 
     inaltimea stivei trebuie sa fie tabObj.length+1, deoarece
     primul din stiva este elementul de garda
  */
  protected Object solutie() {
    if(stiva.size()<tabObj.length+1) return null;
    ArrayList solutie=new ArrayList();
    for(int j=1; j<stiva.size(); j++) {
      ElemStiva elementCurent=(ElemStiva)stiva.get(j);
      int indice=((Integer)elementCurent.element).intValue();
      solutie.add(tabObj[indice]);
    }
    return solutie;
  }

  /* Succesor poate fi un obiect din tabObj. Se ia cel care urmeaza
     dupa ultimul folosit
  */
  protected Object succesor() {
    if(tabObj.length==0) return null;
    if(stiva.isEmpty() || stiva.size()==(tabObj.length+1))
           return null;
    int j;
    ElemStiva varfStiva=(ElemStiva)stiva.get(stiva.size()-1);
    if(varfStiva.ultimSuccesorVizitat==null) return new Integer(0);
    j=((Integer)varfStiva.ultimSuccesorVizitat).intValue();
    if(j>=tabObj.length-1) return null;
    return new Integer(j+1);
  }

  /* Valid poate fi numai un succesor care nu exista deja in stiva
  */
  protected boolean esteValid(Object succesor) {
    boolean valid=true;
    int inaltimeStiva=stiva.size();
    int k=((Integer)succesor).intValue();
    for(int i=1; i<inaltimeStiva && valid; i++) {
      ElemStiva curent=(ElemStiva)stiva.get(i);
      int j=((Integer)curent.element).intValue();
      if(k==j) valid=false;
    }
    return valid;
  }
}
    