import java.util.*;

public class ArbAcopPrim {

  Collection graf;
  Set multimeNoduri=new HashSet();
  int numarNoduri;

  public ArbAcopPrim(Collection muchiiGraf) {
    graf=muchiiGraf;
  }

  public Collection arbore(String nodPornire) {
    /* Se construieste o copie a grafului dat (ca o multime de noduri si o
       colectie de muchii)
    */
    Collection candidati=new ArrayList();
    Iterator iter=graf.iterator();
    Muchie m;
    while(iter.hasNext()) {
      m=(Muchie)iter.next();
      candidati.add(m);
      multimeNoduri.add(m.nod1);
      multimeNoduri.add(m.nod2);
    }
    numarNoduri=multimeNoduri.size();
    multimeNoduri=null; // nu mai este necesara
    /* Se initializeaza arborele de acoperire (ca o colectie de muchii) si multimea
       nodurilor arborelui
    */
    Collection arbAcop=new ArrayList();
    Set noduriArbore=new HashSet();
    noduriArbore.add(nodPornire);
    /* Se genereaza arborele de acoperire de cost minim prin algoritmul Prim
    */
    boolean existaCandidati=true, contineNod1, contineNod2;
    while(noduriArbore.size()<numarNoduri&&existaCandidati) {
      /* Se cauta muchia de cost minim care are un nod in arbore. Totodata, 
         se elimina muchiile care au ambele noduri in arbore
      */
      iter=candidati.iterator(); // se itereaza muchiile candidate
      Muchie candidatSelectat=null;
      while (iter.hasNext()) {
        m=(Muchie)iter.next();
        contineNod1=noduriArbore.contains(m.nod1);
        contineNod2=noduriArbore.contains(m.nod2);
        if(contineNod1&&contineNod2) iter.remove();// se elimina muchiia curenta
        else if(contineNod1 || contineNod2) {
          if(candidatSelectat==null || candidatSelectat.compareTo(m)>0) 
            candidatSelectat=m;
        }
      }
     
      if(candidatSelectat==null) existaCandidati=false; // nu mai exista candidati
      else { // muchia de cost minim se pune in arbore
        arbAcop.add(candidatSelectat);
        if(noduriArbore.contains(candidatSelectat.nod1))
          noduriArbore.add(candidatSelectat.nod2);
        else noduriArbore.add(candidatSelectat.nod1);
      } 
    } 
    return arbAcop;
  }
    
  static class Muchie implements Comparable {
    String nod1, nod2;
    double cost;

    public Muchie(String nod1, String nod2, double cost) {
      this.nod1=nod1;
      this.nod2=nod2;
      this.cost=cost;
    }

    public String toString() {
      return "("+nod1+"-"+nod2+": cost="+cost+")";
    }

    public int compareTo(Object ob) {
      double dif=cost-((Muchie)ob).cost;
      if (dif<0) return -1;
      if (dif>0) return 1;
      return 0;
    }
  }
}    